/*******************************************************************************
* Copyright 2007 Seapine Software, Inc. All rights reserved.
*
* IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
* in consideration of your agreement to the following terms, and your use, installation,
* modification or redistribution of this Software constitutes acceptance of these terms.
* If you do not agree with these terms, please do not use, install, modify or redistribute
* this Software.
*
* In consideration of your agreement to abide by the following terms, and subject to these
* terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
* this original Seapine software (the Software), to use, reproduce, modify and redistribute
* the Software, with or without modifications, in source and/or binary forms; provided that
* if you redistribute the Software in its entirety and without modifications, you must retain
* this notice and the following text and disclaimers in all such redistributions of the Software.
* Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
* or promote products derived from the Software without specific prior written permission from
* Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
* implied, are granted by Seapine herein, including but not limited to any patent rights that
* may be infringed by your derivative works or by other works in which the Software may be
* incorporated.
*
* The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
* EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
* OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
*
* IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
* DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
* REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
* UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
* IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************************/
using System;
using System.Collections;
using System.Text;
using SPSTools;

namespace CreateDefect
{
   class CreateDefect
   {
      static Hashtable buildValueHash()
      {
         Hashtable hash = new Hashtable();
         try
         {
            // Flip the comments here to test this w/o a TT trigger.
            hash.Add("Number", Environment.GetEnvironmentVariable("TRTCN") + " - " + Environment.GetEnvironmentVariable("TRNUM"));
//            hash.Add("Number", "1-2");
            hash.Add("Url", Environment.GetEnvironmentVariable("TTSTUDIOURL"));
//            hash.Add("Url", "ttstudio://localhost:99//CreateDefect/tstr?recordID=34");
            hash.Add("Type", "Bug"); // Makes more sense to hard-code.
            hash.Add("Summary", Environment.GetEnvironmentVariable("TRSUM"));
//            hash.Add("Summary", "My new defect!");
            hash.Add("Description", Environment.GetEnvironmentVariable("TRSTP"));
//            hash.Add("Description", "*Start TestTrack Client  *On the server login screen, log in with the newly created user to the server that contains the projects from the set up steps *Click Connect +Verify that the Project login screen appears +Verify that ONLY the projects the user is assigned to are listed with the project drop down *Select one of the projects *Click OK +Verify the user is logged into the project");
         }
         catch (Exception p_exception)
         {
            Console.WriteLine("Building value table failed: " + p_exception.Message);
         }
         return (hash);
      }

      static void Main(string[] p_args)
      {
         try
         {
            Logger logger = new Logger("C:\\CreateDefect.log");

            if (p_args.Length != 4)
            {
               logger.log("You must pass 3 parameters; \"Jira Soap RPC Url\" \"Jira project name\" \"username\" \"password\"");
               return;
            }

            JiraConnector jira = new JiraConnector(logger, p_args[0]);
            jira.run(p_args[1], p_args[2], p_args[3], buildValueHash());
         }
         catch (Exception p_exception)
         {
            Console.WriteLine("Startup Failed: " + p_exception.Message);
         }
      }
   }
}
